## The Team

| Unity ID | Name               |
| -------- | ------------------ |
| athorve  | Atharva Thorve      |
| dakalath  | Divit Kalathil     |
| mjoshi6  | Mrityunjay Joshi      |
| rnarula2   | Raghav Narula |

## Part I: Scorecards

### **Repo Link:** https://github.com/Mrityunjay243/dollar_bot
**Total Score:** 78/83
| Notes | Score | Evidence/Comments/Links |
| ----- | ----- | ------------------------ |
| Short release cycles | 3 | 2 Releases -> [Release Link](https://github.com/Mrityunjay243/dollar_bot/releases) |
| Workload is spread over the whole team | 3 | Each member worked on a different feature -> [Team Pulse](https://github.com/Mrityunjay243/dollar_bot/pulse) |
| Docs: why: docs tell a story, motivate the whole thing, deliver a punchline that makes you want to rush out and use the thing | 3 | Updated documentation for each feature -> [Docs Link](https://github.com/Mrityunjay243/dollar_bot/tree/main/docs) |
| File CONTRIBUTING.md lists coding standards and lots of tips on how to extend the system without screwing things up | 2 | [Contributing Link](https://github.com/Mrityunjay243/dollar_bot/blob/main/CONTRIBUTING.md) |
| Docs: doco generated, format not ugly | 3 | [Docs Link](https://github.com/Mrityunjay243/dollar_bot/tree/main/docs) |
| Evidence that the whole team is using the same tools (e.g. config files in the repo, updated by lots of different people) | 3 | - |
| Evidence that the members of the team are working across multiple places in the code base | 3 | [Team Pulse](https://github.com/Mrityunjay243/dollar_bot/pulse) |
| Docs: what: point descriptions of each class/function (in isolation) | 3 | [Docs Link](https://github.com/Mrityunjay243/dollar_bot/tree/main/docs) |
| Number of commits: by different people | 3 | [Commit Activity](https://github.com/Mrityunjay243/dollar_bot/graphs/commit-activity) |
| Issues are being closed | 3 | 11 Issues closed -> [Closed Issues Link](https://github.com/Mrityunjay243/dollar_bot/issues?q=is%3Aissue+is%3Aclosed) |
| Issues are discussed before they are closed | 3 | Each issue updated with the discussion before closing and comments added -> [Discussion Link](https://github.com/Mrityunjay243/dollar_bot/issues?q=is%3Aissue+is%3Aclosed) |
| Use of syntax checkers | 2 | Use of Flake8, updated in travis.yml -> [Travis Config Link](https://github.com/Mrityunjay243/dollar_bot/blob/main/.travis.yml) |
| Issues reports | 2 | [Issues Link](https://github.com/Mrityunjay243/dollar_bot/issues) |
| Use of code formatters | 2 | Config files in GH showing your this formatter's config -> Use of Flake8, updated in travis.yml -> [Travis Config Link](https://github.com/Mrityunjay243/dollar_bot/blob/main/.travis.yml) |
| Use of style checkers | 2 | Config files in GH showing your config -> Use of Flake8, updated in travis.yml -> [Travis Config Link](https://github.com/Mrityunjay243/dollar_bot/blob/main/.travis.yml) |
| Docs: short video, animated, hosted on your repo. That convinces people why they want to work on your code | 3 | Added in Readme.md -> [Video Link](https://github.com/Mrityunjay243/dollar_bot/blob/main/README.md) |
| Test cases exist | 2 | 110 test cases with coverage > 80% for each file -> [Test Cases Link](https://github.com/Mrityunjay243/dollar_bot/tree/main/test) |
| Use of code coverage | 2 | [Travis Config Link](https://github.com/Mrityunjay243/dollar_bot/blob/main/.travis.yml) |
| Other automated analysis tools | 2 | [Travis Config Link](https://github.com/Mrityunjay243/dollar_bot/blob/main/.travis.yml) |
| Test cases: a large proportion of the issues related to handling failing cases. (if a test case fails, open an issue and fix it | 2 | [Issues Link](https://github.com/Mrityunjay243/dollar_bot/issues) |
| Test cases are routinely executed | 1 | [Codecov Link](https://app.codecov.io/gh/sak007/MyDollarBot-BOTGo) |
| Documentation describing how this version improves on the older version | 3 | Updated README.md to show the Delta -> [Docs Link](https://github.com/Mrityunjay243/dollar_bot/blob/main/README.md) |
| This version is a little(1), some(2), much(3) improved on the last version | 3 | Tutor's assessment |
| DOI Badge: exists | 3 | [DOI Badge](https://zenodo.org/records/10019964) |
| Docs: how: for common use cases X,Y,Z mini-tutorials showing worked examples on how to do X,Y,Z | 3 | [Docs Link](https://github.com/Mrityunjay243/dollar_bot/tree/main/docs) |
| Video (at least 2 mins) | 3 | [Video Link](https://youtu.be/T8yfeBl6-0A) |
| Use of Version controls | 3 | Github is a version control tool |
| Chat channel exists | 3 | [Discord Link](https://discord.com/channels/1175972668118405130/1175972668118405133) |
| Total | 73 | - |

### ONLINE SUSTAINABILITY QUESTIONNAIRE

| Question                                                                                                                                                                                                                                          | Answer         | Comments                                                                                                                                                                                                                            |
| ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Does your website and documentation provide a clear, high-level overview of your software?                                                                                                                                                        | Yes            |   [README](https://github.com/Mrityunjay243/dollar_bot/blob/main/README.md)                                                                                                                                                                                                                             |
| Does your website and documentation clearly describe the type of user who should use your software?                                                                                                                                               | Yes            |   [README](https://github.com/Mrityunjay243/dollar_bot/blob/main/README.md)                                                                                                                                                                                                                                   |
| Do you publish case studies to show how your software has been used by yourself and others?                                                                                                                                                       | No             |                                                                                                                                                                                                                                     |
| Is the name of your project/software unique?                                                                                                                                                                                                      | Yes            |                                                                                                                                                                                                                                     |
| Is your project/software name free from trademark violations?                                                                                                                                                                                     | Yes            |                                                                                                                                                                                                                                     |
| Is your software available as a package that can be deployed without building it?                                                                                                                                                                 | No             |                                                                                                                                                                                                                                     |
| Is your software available for free?                                                                                                                                                                                                              | Yes            |   [License](https://github.com/Mrityunjay243/dollar_bot/blob/main/README.md#License)                                                                                                                                                                                                                                  |
| Is your source code publicly available to download, either as a downloadable bundle or via access to a source code repository?                                                                                                                    | Yes            |   https://github.com/Mrityunjay243/dollar_bot                                                                                                                                                                                                                                  |
| Is your software hosted in an established, third-party repository likeGitHub (https://github.com), BitBucket (https://bitbucket.org),LaunchPad (https://launchpad.net) orSourceForge (https://sourceforge.net)?                                   | Yes            |   GitHub                                                                                                                                                                                                                              |
| Is your documentation clearly available on your website or within your software?                                                                                                                                                                  | Yes            |   [README](https://github.com/Mrityunjay243/dollar_bot/blob/main/README.md                                                                                                                                                                                                                                   |
| Does your documentation include a "quick start" guide, that provides a short overview of how to use your software with some basic examples of use?                                                                                                | Yes            |   [How To Run](https://github.com/Mrityunjay243/dollar_bot/blob/main/README.md#how-to-run)                                                                                                                                                                                                                                 |
| If you provide more extensive documentation, does this provide clear, step-by-step instructions on how to deploy and use your software?                                                                                                           | Yes            |   Step by step instructions on how to run and use the application: https://github.com/Mrityunjay243/dollar_bot/blob/main/README.md#how-to-run                                                                                                                                                                                                                                  |
| Do you provide a comprehensive guide to all your software’s commands, functions and options?                                                                                                                                                      | Yes            |   [Functional Documentation](https://github.com/Mrityunjay243/dollar_bot/tree/main/docs)                                                                                                                                                                                                                                 |
| Do you provide troubleshooting information that describes the symptoms and step-by-step solutions for problems and error messages?                                                                                                                | Yes            | Ref: [Support](https://github.com/Mrityunjay243/dollar_bot/blob/main/docs/support.md)                                                           |
| If your software can be used as a library, package or service by other software, do you provide comprehensive API documentation?                                                                                                                  | Yes            |  The Telegram Bot has been integrated with Discord and Slack                                                                                                                                                                                                                                    |
| Do you store your documentation under revision control with your source code?                                                                                                                                                                     | Yes            |                                                                                                                                                                                                                                     |
| Do you publish your release history e.g. release data, version numbers, key features of each release etc. on your web site or in your documentation?                                                                                              | Yes            | Ref: [Releases](https://github.com/Mrityunjay243/dollar_bot/releases)                                                                                                   |
| Does your software describe how a user can get help with using your software?                                                                                                                                                                     | Yes            | We have a Contact Us Page on our application                                                                                                                                               |
| Does your website and documentation describe what support, if any, you provide to users and developers?                                                                                                                                           | Yes            | We are open to accept new bug requests or ideas                                                                                                                                                                                                                                  |
| Does your project have an e-mail address or forum that is solely for supporting users?                                                                                                                                                            | Yes            | We have a Contact Us Page on our application and a Troubleshooting guide in our repo.                                                                                                                                               |
| Are e-mails to your support e-mail address received by more than one person?                                                                                                                                                                      | Yes            | Ref: https://github.com/Mrityunjay243/dollar_bot/tree/main#contributors                                                 |
| Does your project have a ticketing system to manage bug reports and feature requests?                                                                                                                                                             | Yes            | Ref: [Contributing System](https://github.com/Mrityunjay243/dollar_bot/blob/main/CONTRIBUTING.md)                                                                                           |
| Is your project's ticketing system publicly visible to your users, so they can view bug reports and feature requests?                                                                                                                             | Yes            | Ref: [Issues](https://github.com/Mrityunjay243/dollar_bot/issues)                                                                                                       |
| Is your software’s architecture and design modular?                                                                                                                                                                                               | Yes            | We have implemented the software architecture by dividing functionalities into smaller chunks                                                                                                                                                                                                                                 |
| Does your software use an accepted coding standard or convention?                                                                                                                                                                                 | Yes            | We use Pep8 to maintain conventions                                                                                                                                                                                                                                    |
| Does your software allow data to be imported and exported using open data formats? e.g. GIF, SVG, HTML, XML, tar, zip, CSV, JSON, NetCDF, or domain specific ones                                                                                 | No            | Chatbot deals with just text based commands                                                                                                                |
| Does your software allow communications using open communications protocols? e.g. HTTP, FTP, XMPP, SOAP over HTTP, or domain-specific ones                                                                                                        | Yes            | Requests are being made using Telegram API                                                                                                                                                                                                                                  |
| Is your software cross-platform compatible? e.g. does it run under two or more of Windows, Unix/Linux and Mac OS X, or can be used from within two or more of Internet Explorer, Chrome, Firefox and Safari?                                      | Yes            | The application is cross platform                                                                                                                                                                                                                                    |
| Does your software adhere to appropriate accessibility conventions or standards?                                                                                                                                                                  | Yes            | Eg. Text sizing has been kept across all pages                                                                                                                                                                                               |
| Does your documentation adhere to appropriate accessibility conventions or standards?                                                                                                                                                             | Yes            | Yes, Images do have alternate text.                                                                                                                                                              |
| Is your source code stored in a repository under revision control?                                                                                                                                                                                | Yes            |                                                                                                                                                                                                                                     |
| Is each source code release a snapshot of the repository?                                                                                                                                                                                         | Yes            | Release has the entire source code                                                                                                                                                                                                     |
| Are releases tagged in the repository?                                                                                                                                                                                                            | Yes            | Ref: [https://github.com/Mrityunjay243/dollar_bot/releases](https://github.com/Mrityunjay243/dollar_bot/releases)                                                                                                   |
| Is there a branch of the repository that is always stable? (i.e. tests always pass, code always builds successfully)                                                                                                                              | Yes            | Main branch                                                                                                                                                                                                                                 |
| Do you provide publicly-available instructions for building your software from the source code?                                                                                                                                                   | Yes            |  Readme                                                                                                                                                                                                                                   |
| Can you build, or package, your software using an automated tool?                                                                                                                                                                                 | Yes            | Setup.py and PIP                                                                                                                                                                                                                                   |
| Do you provide publicly-available instructions for deploying your software?                                                                                                                                                                       | No             |                                                                                                                                                                                                                                     |
| Does your documentation list all third-party dependencies?                                                                                                                                                                                        | Yes            | https://github.com/Mrityunjay243/dollar_bot/blob/main/requirements.txt                                                                                                                                                                                                                                    |
| Does your documentation list the version number for all third-party dependencies?                                                                                                                                                                 | Yes            | Requirements.txt                                                                                                                                                                                                   |
| Does your software list the web address, and licences for all third-party dependencies and say whether the dependencies are mandatory or optional?                                                                                                | Yes            | https://github.com/Mrityunjay243/dollar_bot/blob/main/requirements.txt                                                                                                                                                                                                                                   |
| Can you download dependencies using a dependency management tool or package manager?                                                                                                                                                              | Yes            | setup.py and pip                                                                                                                                                                                                                         |
| Do you have tests that can be run after your software has been built or deployed to show whether the build or deployment has been successful?                                                                                                     | Yes            |                                                                                                                                                                                                                                     |
| Do you have an automated test suite for your software?                                                                                                                                                                                            | Yes            | unittest is used                                                                                                                                                                                                                                   |
| Do you have a framework to periodically (e.g. nightly) run your tests on the latest version of the source code?                                                                                                                                   | Yes            | Refer: https://github.com/Mrityunjay243/dollar_bot/tree/main/.github                                                                                                                                                                                                          |
| Do you use continuous integration, automatically running tests whenever changes are made to your source code?                                                                                                                                     | Yes            | Refer: https://github.com/adi-kiran/burnout-healthgoalsapp/blob/main/.github/workflows/unit_test.yml                                                                                                                                                                                                                                    |
| Are your test results publicly visible?                                                                                                                                                                                                           | No            | Refer:                                                                                                                                                                                                                                    |
| Are all manually-run tests documented?                                                                                                                                                                                                            | Not applicable |                                                                                                   |
|Does your website state how many projects and users are associated with your project?                                                                                                                                                             | Yes            |                                                                                                                                                                                                                                     |
| Do you provide success stories on your website?                                                                                                                                                                                                   | No             |                                                                                                                                                                                                                                     |
| Do you list your important partners and collaborators on your website?                                                                                                                                                                            | Yes            | https://github.com/Mrityunjay243/dollar_bot#contributors                                                                                                                                                                                                                                   |
| Do you list your project's publications on your website or link to a resource where these are available?                                                                                                                                          | Not applicable |                                                                                                                                                                                                                                     |
| Do you list third-party publications that refer to your software on your website or link to a resource where these are available?                                                                                                                 | Not applicable |                                                                                                                                                                                                                                     |
| Can users subscribe to notifications to changes to your source code repository?                                                                                                                                                                   | Yes            |  Users can subscribe to get notified about changes to repository on github                                                                                                                                                                                                                                   |
| If your software is developed as an open source project (and, not just a project developing open source software), do you have a governance model?                                                                                                | Yes            |  [Code of Conduct](https://github.com/Mrityunjay243/dollar_bot/blob/main/CODE_OF_CONDUCT.md)                                                                                                                                                                                                                                   |
| Do you accept contributions (e.g. bug fixes, enhancements, documentation updates, tutorials) from people who are not part of your project?                                                                                                        | Yes            | Ref: [CONTRIBUTING]([https://github.com/adi-kiran/burnout-healthgoalsapp/blob/main/CONTRIBUTING.md](https://github.com/Mrityunjay243/dollar_bot/blob/main/CONTRIBUTING.md))                                                                                           |
| Do you have a contributions policy?                                                                                                                                                                                                               | Yes            | Ref: [CONTRIBUTING]([https://github.com/adi-kiran/burnout-healthgoalsapp/blob/main/CONTRIBUTING.md](https://github.com/Mrityunjay243/dollar_bot/blob/main/CONTRIBUTING.md))                                                                  |
| Is your contributions' policy publicly available?                                                                                                                                                                                                 | Yes            | Ref: [CONTRIBUTING](https://github.com/Mrityunjay243/dollar_bot/blob/main/CONTRIBUTING.md))                                                                 |
| Do contributors keep the copyright/IP of their contributions?                                                                                                                                                                                     | No            |                                                                                                                                                                                                                                     |
| Does your website and documentation clearly state the copyright owners of your software and documentation?                                                                                                                                        | Yes            | Ref: [[License](https://github.com/Mrityunjay243/dollar_bot/blob/main/LICENSE) We also have a footer on the website with the License and Copyright mentioned. |
| Does each of your source code files include a copyright statement?                                                                                                                                                                                | Not applicable |                                                                                                                                                                                                                                     |
| Does your website and documentation clearly state the licence of your software?                                                                                                                                                                   | Yes            | Ref: [License](https://github.com/Mrityunjay243/dollar_bot/blob/main/LICENSE) We also have a footer on the website with the License and Copyright mentioned. |
| Is your software released under an open source licence?                                                                                                                                                                                           | Yes            | MIT License.                                                                                                                                                                                                                        |
| Is your software released under an OSI-approved open-source licence?                                                                                                                                                                              | Yes            | MIT License is an OSI-approved open-source license.                                                                                                                                                                                 |
| Does each of your source code files include a licence header?                                                                                                                                                                                     | Yes |          https://github.com/Mrityunjay243/dollar_bot/blob/main/LICENSE                                                                                                                                                                                                                           |
| Do you have a recommended citation for your software?                                                                                                                                                                                             | NA            |                                                                                                                                                                                         |
| Does your website or documentation include a project roadmap (a list of project and development milestones for the next 3, 6 and 12 months)?                                                                                                      | Yes            | Issues: https://github.com/Mrityunjay243/dollar_bot/issues                                                                                                                          |
| Does your website or documentation describe how your project is funded, and the period over which funding is guaranteed?                                                                                                                          | Not applicable |                                                                                                                                                                                                                                     |
| Do you make timely announcements of the deprecation of components, APIs, etc.?                                                                                                                                                                    | Yes            | https://github.com/Mrityunjay243/dollar_bot/wiki                             |

